Index: bfd/elf32-m32r.c
===================================================================
RCS file: /cvs/src/src/bfd/elf32-m32r.c,v
retrieving revision 1.38
diff -c -r1.38 elf32-m32r.c
*** bfd/elf32-m32r.c	3 Dec 2003 17:38:48 -0000	1.38
--- bfd/elf32-m32r.c	18 Dec 2003 10:04:33 -0000
***************
*** 1307,1312 ****
--- 3225,3577 ----
  
    return ret;
  }
+ 
+ /* Finish up dynamic symbol handling.  We set the contents of various
+    dynamic sections here.  */
+ static bfd_boolean
+ m32r_elf_finish_dynamic_symbol (output_bfd, info, h, sym)
+      bfd *output_bfd;
+      struct bfd_link_info *info;
+      struct elf_link_hash_entry *h;
+      Elf_Internal_Sym *sym;
+ {
+   struct elf_m32r_link_hash_table *htab;
+   bfd *dynobj;
+   bfd_byte *loc;
+  
+ #ifdef DEBUG_PIC
+ printf("m32r_elf_finish_dynamic_symbol()\n");
+ #endif
+   
+   htab = m32r_elf_hash_table (info);
+   dynobj = htab->root.dynobj;
+ 
+   if (h->plt.offset != (bfd_vma) -1)
+     {
+       asection *splt;
+       asection *sgot;
+       asection *srela;
+ 
+       bfd_vma plt_index;
+       bfd_vma got_offset;
+       Elf_Internal_Rela rela;
+  
+       /* This symbol has an entry in the procedure linkage table.  Set
+          it up.  */
+  
+       BFD_ASSERT (h->dynindx != -1);
+  
+       splt = htab->splt;
+       sgot = htab->sgotplt;
+       srela = htab->srelplt;
+       BFD_ASSERT (splt != NULL && sgot != NULL && srela != NULL);
+ 
+       /* Get the index in the procedure linkage table which
+          corresponds to this symbol.  This is the index of this symbol
+          in all the symbols for which we are making plt entries.  The
+          first entry in the procedure linkage table is reserved.  */
+       plt_index = h->plt.offset / PLT_ENTRY_SIZE - 1;
+ 
+       /* Get the offset into the .got table of the entry that
+         corresponds to this function.  Each .got entry is 4 bytes.
+         The first three are reserved.  */
+       got_offset = (plt_index + 3) * 4;
+ 
+       /* Fill in the entry in the procedure linkage table.  */
+       if (! info->shared)
+         {
+           bfd_put_32 (output_bfd,
+               (PLT_ENTRY_WORD0b
+                + (((sgot->output_section->vma
+                     + sgot->output_offset
+                     + got_offset) >> 16) & 0xffff)),
+               splt->contents + h->plt.offset);
+           bfd_put_32 (output_bfd,
+               (PLT_ENTRY_WORD1b
+                + ((sgot->output_section->vma
+                    + sgot->output_offset
+                    + got_offset) & 0xffff)),
+               splt->contents + h->plt.offset + 4);
+           bfd_put_32 (output_bfd, PLT_ENTRY_WORD2,
+               splt->contents + h->plt.offset + 8);
+           bfd_put_32 (output_bfd,
+               (PLT_ENTRY_WORD3
+                + plt_index * sizeof (Elf32_External_Rela)),
+               splt->contents + h->plt.offset + 12);
+           bfd_put_32 (output_bfd,
+               (PLT_ENTRY_WORD4
+                + (((unsigned int) ((- (h->plt.offset + 16)) >> 2)) & 0xffffff)),
+               splt->contents + h->plt.offset + 16);
+         }
+       else
+         {
+           bfd_put_32 (output_bfd,
+               PLT_ENTRY_WORD0 + got_offset,
+               splt->contents + h->plt.offset);
+           bfd_put_32 (output_bfd, PLT_ENTRY_WORD1,
+               splt->contents + h->plt.offset + 4);
+           bfd_put_32 (output_bfd, PLT_ENTRY_WORD2,
+               splt->contents + h->plt.offset + 8);
+           bfd_put_32 (output_bfd,
+               (PLT_ENTRY_WORD3
+                + plt_index * sizeof (Elf32_External_Rela)),
+               splt->contents + h->plt.offset + 12);
+           bfd_put_32 (output_bfd,
+               (PLT_ENTRY_WORD4
+                + (((unsigned int) ((- (h->plt.offset + 16)) >> 2)) & 0xffffff)),
+               splt->contents + h->plt.offset + 16);
+         }
+  
+       /* Fill in the entry in the global offset table.  */
+       bfd_put_32 (output_bfd,
+                   (splt->output_section->vma
+                    + splt->output_offset
+                    + h->plt.offset
+                    + 12), /* same offset */
+                   sgot->contents + got_offset);
+ 
+       /* Fill in the entry in the .rela.plt section.  */
+       rela.r_offset = (sgot->output_section->vma
+                        + sgot->output_offset
+                        + got_offset);
+       rela.r_info = ELF32_R_INFO (h->dynindx, R_M32R_JMP_SLOT);
+       rela.r_addend = 0;
+       loc = srela->contents;
+       loc += plt_index * sizeof(Elf32_External_Rela);
+       bfd_elf32_swap_reloca_out (output_bfd, &rela, loc);
+  
+       if ((h->elf_link_hash_flags & ELF_LINK_HASH_DEF_REGULAR) == 0)
+         {
+           /* Mark the symbol as undefined, rather than as defined in
+              the .plt section.  Leave the value alone.  */
+           sym->st_shndx = SHN_UNDEF;
+         }
+     }
+ 
+   if (h->got.offset != (bfd_vma) -1)
+     {
+       asection *sgot;
+       asection *srela;
+       Elf_Internal_Rela rela;
+  
+       /* This symbol has an entry in the global offset table.  Set it
+          up.  */
+  
+       sgot = htab->sgot;
+       srela = htab->srelgot;
+       BFD_ASSERT (sgot != NULL && srela != NULL);
+  
+       rela.r_offset = (sgot->output_section->vma
+                        + sgot->output_offset
+                        + (h->got.offset &~ 1));
+  
+       /* If this is a -Bsymbolic link, and the symbol is defined
+          locally, we just want to emit a RELATIVE reloc.  Likewise if
+          the symbol was forced to be local because of a version file.
+          The entry in the global offset table will already have been
+          initialized in the relocate_section function.  */
+       if (info->shared
+           && (info->symbolic
+ 	      || h->dynindx == -1
+ 	      || (h->elf_link_hash_flags & ELF_LINK_FORCED_LOCAL))
+           && (h->elf_link_hash_flags & ELF_LINK_HASH_DEF_REGULAR))
+         {
+           rela.r_info = ELF32_R_INFO (0, R_M32R_RELATIVE);
+           rela.r_addend = (h->root.u.def.value
+                            + h->root.u.def.section->output_section->vma
+                            + h->root.u.def.section->output_offset);
+         }
+       else
+         {
+ 	  BFD_ASSERT((h->got.offset & 1) == 0);
+           bfd_put_32 (output_bfd, (bfd_vma) 0, sgot->contents + h->got.offset);
+           rela.r_info = ELF32_R_INFO (h->dynindx, R_M32R_GLOB_DAT);
+           rela.r_addend = 0;
+         }
+  
+       loc = srela->contents;
+       loc += srela->reloc_count * sizeof(Elf32_External_Rela);
+       bfd_elf32_swap_reloca_out (output_bfd, &rela, loc);
+       ++srela->reloc_count;
+     }
+  
+   if ((h->elf_link_hash_flags & ELF_LINK_HASH_NEEDS_COPY) != 0)
+     {
+       asection *s;
+       Elf_Internal_Rela rela;
+  
+       /* This symbols needs a copy reloc.  Set it up.  */
+  
+       BFD_ASSERT (h->dynindx != -1
+                   && (h->root.type == bfd_link_hash_defined
+                       || h->root.type == bfd_link_hash_defweak));
+  
+       s = bfd_get_section_by_name (h->root.u.def.section->owner,
+                                    ".rela.bss");
+       BFD_ASSERT (s != NULL);
+  
+       rela.r_offset = (h->root.u.def.value
+                        + h->root.u.def.section->output_section->vma
+                        + h->root.u.def.section->output_offset);
+       rela.r_info = ELF32_R_INFO (h->dynindx, R_M32R_COPY);
+       rela.r_addend = 0;
+       loc = s->contents;
+       loc += s->reloc_count * sizeof(Elf32_External_Rela);
+       bfd_elf32_swap_reloca_out (output_bfd, &rela, loc);
+       ++s->reloc_count;
+     }
+  
+   /* Mark some specially defined symbols as absolute.  */
+   if (strcmp (h->root.root.string, "_DYNAMIC") == 0
+       || strcmp (h->root.root.string, "_GLOBAL_OFFSET_TABLE_") == 0)
+     sym->st_shndx = SHN_ABS;
+  
+   return TRUE;
+ }
+ 
+ 
+ /* Finish up the dynamic sections.  */
+  
+ static bfd_boolean
+ m32r_elf_finish_dynamic_sections (output_bfd, info)
+      bfd *output_bfd;
+      struct bfd_link_info *info;
+ {
+   struct elf_m32r_link_hash_table *htab;
+   bfd *dynobj;
+   asection *sdyn;
+   asection *sgot;
+ 
+ #ifdef DEBUG_PIC
+ printf("m32r_elf_finish_dynamic_sections()\n");
+ #endif
+  
+   htab = m32r_elf_hash_table (info);
+   dynobj = htab->root.dynobj;
+ 
+   sgot = htab->sgotplt;
+   sdyn = bfd_get_section_by_name (dynobj, ".dynamic");
+  
+   if (htab->root.dynamic_sections_created)
+     {
+       asection *splt;
+       Elf32_External_Dyn *dyncon, *dynconend;
+  
+       BFD_ASSERT (sgot != NULL && sdyn != NULL);
+  
+       dyncon = (Elf32_External_Dyn *) sdyn->contents;
+       dynconend = (Elf32_External_Dyn *) (sdyn->contents + sdyn->_raw_size);
+ 
+       for (; dyncon < dynconend; dyncon++)
+         {
+           Elf_Internal_Dyn dyn;
+           const char *name;
+           asection *s;
+  
+           bfd_elf32_swap_dyn_in (dynobj, dyncon, &dyn);
+  
+           switch (dyn.d_tag)
+             {
+             default:
+               break;
+ 
+             case DT_PLTGOT:
+               name = ".got";
+               s = htab->sgot->output_section; 
+               goto get_vma;
+             case DT_JMPREL:
+               name = ".rela.plt";
+               s = htab->srelplt->output_section;
+             get_vma:
+               BFD_ASSERT (s != NULL);
+               dyn.d_un.d_ptr = s->vma;
+               bfd_elf32_swap_dyn_out (output_bfd, &dyn, dyncon);
+               break;
+ 
+             case DT_PLTRELSZ:
+               s = htab->srelplt->output_section;
+               BFD_ASSERT (s != NULL);
+               if (s->_cooked_size != 0)
+                 dyn.d_un.d_val = s->_cooked_size;
+               else
+                 dyn.d_un.d_val = s->_raw_size;
+               bfd_elf32_swap_dyn_out (output_bfd, &dyn, dyncon);
+               break;
+ 
+             case DT_RELASZ:
+               /* My reading of the SVR4 ABI indicates that the
+                  procedure linkage table relocs (DT_JMPREL) should be
+                  included in the overall relocs (DT_RELA).  This is
+                  what Solaris does.  However, UnixWare can not handle
+                  that case.  Therefore, we override the DT_RELASZ entry
+                  here to make it not include the JMPREL relocs.  Since
+                  the linker script arranges for .rela.plt to follow all
+                  other relocation sections, we don't have to worry
+                  about changing the DT_RELA entry.  */
+               if (htab->srelplt != NULL)
+                 {
+                   s = htab->srelplt->output_section;
+                   if (s->_cooked_size != 0)
+                     dyn.d_un.d_val -= s->_cooked_size;
+                   else
+                     dyn.d_un.d_val -= s->_raw_size;
+                 }
+               bfd_elf32_swap_dyn_out (output_bfd, &dyn, dyncon);
+               break;
+             }
+         }
+  
+       /* Fill in the first entry in the procedure linkage table.  */
+       splt = htab->splt;
+       if (splt && splt->_raw_size > 0)
+         {
+           if (info->shared)
+             {
+               bfd_put_32 (output_bfd, PLT0_PIC_ENTRY_WORD0, splt->contents);
+               bfd_put_32 (output_bfd, PLT0_PIC_ENTRY_WORD1, splt->contents + 4);
+               bfd_put_32 (output_bfd, PLT0_PIC_ENTRY_WORD2, splt->contents + 8);
+               bfd_put_32 (output_bfd, PLT0_PIC_ENTRY_WORD3, splt->contents + 12);
+               bfd_put_32 (output_bfd, PLT0_PIC_ENTRY_WORD4, splt->contents + 16);
+             }
+           else
+             {
+               unsigned long addr;
+               /* addr = .got + 4 */
+               addr = sgot->output_section->vma + sgot->output_offset + 4;
+               bfd_put_32 (output_bfd,
+ 			  PLT0_ENTRY_WORD0 | ((addr >> 16) & 0xffff),
+ 			  splt->contents);
+               bfd_put_32 (output_bfd, 
+ 			  PLT0_ENTRY_WORD1 | (addr & 0xffff),
+ 			  splt->contents + 4);
+               bfd_put_32 (output_bfd, PLT0_ENTRY_WORD2, splt->contents + 8);
+               bfd_put_32 (output_bfd, PLT0_ENTRY_WORD3, splt->contents + 12);
+               bfd_put_32 (output_bfd, PLT0_ENTRY_WORD4, splt->contents + 16);
+             }
+ 
+           elf_section_data (splt->output_section)->this_hdr.sh_entsize =
+             PLT_ENTRY_SIZE;
+         }
+     }
+ 
+   /* Fill in the first three entries in the global offset table.  */
+   if (sgot && sgot->_raw_size > 0)
+     {
+       if (sdyn == NULL)
+         bfd_put_32 (output_bfd, (bfd_vma) 0, sgot->contents);
+       else
+         bfd_put_32 (output_bfd,
+                     sdyn->output_section->vma + sdyn->output_offset,
+                     sgot->contents);
+       bfd_put_32 (output_bfd, (bfd_vma) 0, sgot->contents + 4);
+       bfd_put_32 (output_bfd, (bfd_vma) 0, sgot->contents + 8);
+ 
+       elf_section_data (sgot->output_section)->this_hdr.sh_entsize = 4;
+     }
+  
+   return TRUE;
+ }
+ 
  
  #if 0 /* relaxing not supported yet */
  
***************
*** 2005,2010 ****
--- 4270,4277 ----
        {
        case R_M32R_GNU_VTINHERIT:
        case R_M32R_GNU_VTENTRY:
+       case R_M32R_RELA_GNU_VTINHERIT:
+       case R_M32R_RELA_GNU_VTENTRY:
          break;
  
        default:
***************
*** 2035,2041 ****
       asection *sec ATTRIBUTE_UNUSED;
       const Elf_Internal_Rela *relocs ATTRIBUTE_UNUSED;
  {
!   /* we don't use got and plt entries for m32r */
    return TRUE;
  }
  
--- 4302,4398 ----
       asection *sec ATTRIBUTE_UNUSED;
       const Elf_Internal_Rela *relocs ATTRIBUTE_UNUSED;
  {
!   /* Update the got entry reference counts for the section being removed.  */
!   Elf_Internal_Shdr *symtab_hdr;
!   struct elf_link_hash_entry **sym_hashes;
!   bfd_signed_vma *local_got_refcounts;
!   const Elf_Internal_Rela *rel, *relend;
!   unsigned long r_symndx;
!   struct elf_link_hash_entry *h;
! 
!   elf_section_data (sec)->local_dynrel = NULL;
! 
!   symtab_hdr = &elf_tdata (abfd)->symtab_hdr;
!   sym_hashes = elf_sym_hashes (abfd);
!   local_got_refcounts = elf_local_got_refcounts (abfd);
! 
!   relend = relocs + sec->reloc_count;
!   for (rel = relocs; rel < relend; rel++)
!     switch (ELF32_R_TYPE (rel->r_info))
!       {
!       case R_M32R_GOT16_HI_ULO:
!       case R_M32R_GOT16_HI_SLO:
!       case R_M32R_GOT16_LO:
!       case R_M32R_GOT24:
!       case R_M32R_GOTPC_HI_ULO:
!       case R_M32R_GOTPC_HI_SLO:
!       case R_M32R_GOTPC_LO:
!       case R_M32R_GOTPC24:
! 	r_symndx = ELF32_R_SYM (rel->r_info);
! 	if (r_symndx >= symtab_hdr->sh_info)
! 	  {
! 	    h = sym_hashes[r_symndx - symtab_hdr->sh_info];
! 	    if (h->got.refcount > 0)
! 	      h->got.refcount--;
! 	  }
! 	else
! 	  {
! 	    if (local_got_refcounts && local_got_refcounts[r_symndx] > 0)
! 	      local_got_refcounts[r_symndx]--;
! 	  }
!         break;
! 
!       case R_M32R_16_RELA:
!       case R_M32R_24_RELA:
!       case R_M32R_32_RELA:
!       case R_M32R_HI16_ULO_RELA:
!       case R_M32R_HI16_SLO_RELA:
!       case R_M32R_LO16_RELA:
!       case R_M32R_SDA16_RELA:
!       case R_M32R_18_PCREL_RELA:
!       case R_M32R_26_PCREL_RELA:
!         r_symndx = ELF32_R_SYM (rel->r_info);
!         if (r_symndx >= symtab_hdr->sh_info)
!           {
!             struct elf_m32r_link_hash_entry *eh;
!             struct elf_m32r_dyn_relocs **pp;
!             struct elf_m32r_dyn_relocs *p;
! 
!             h = sym_hashes[r_symndx - symtab_hdr->sh_info];
! 
!             if (!info->shared && h->plt.refcount > 0)
!               h->plt.refcount -= 1;
! 
!             eh = (struct elf_m32r_link_hash_entry *) h;
! 
!             for (pp = &eh->dyn_relocs; (p = *pp) != NULL; pp = &p->next)
!               if (p->sec == sec)
!                 {
!                   if (ELF32_R_TYPE (rel->r_info) == R_M32R_26_PCREL_RELA
!                       || ELF32_R_TYPE (rel->r_info) == R_M32R_26_PCREL_RELA)
!                     p->pc_count -= 1;
!                   p->count -= 1;
!                   if (p->count == 0)
!                     *pp = p->next;
!                   break;
!                 }
!           }
!         break;
! 
!       case R_M32R_26_PLTREL:
! 	r_symndx = ELF32_R_SYM (rel->r_info);
! 	if (r_symndx >= symtab_hdr->sh_info)
! 	  {
! 	    h = sym_hashes[r_symndx - symtab_hdr->sh_info];
! 	    if (h->plt.refcount > 0)
! 	      h->plt.refcount--;
! 	  }
! 	break;
! 
!       default:
! 	break;
!       }
! 
    return TRUE;
  }
  
***************
*** 2054,2085 ****
    struct elf_link_hash_entry **sym_hashes, **sym_hashes_end;
    const Elf_Internal_Rela *rel;
    const Elf_Internal_Rela *rel_end;
  
    if (info->relocatable)
      return TRUE;
  
    symtab_hdr = &elf_tdata (abfd)->symtab_hdr;
    sym_hashes = elf_sym_hashes (abfd);
    sym_hashes_end = sym_hashes + symtab_hdr->sh_size/sizeof (Elf32_External_Sym);
    if (!elf_bad_symtab (abfd))
      sym_hashes_end -= symtab_hdr->sh_info;
  
    rel_end = relocs + sec->reloc_count;
    for (rel = relocs; rel < rel_end; rel++)
      {
        struct elf_link_hash_entry *h;
        unsigned long r_symndx;
  
        r_symndx = ELF32_R_SYM (rel->r_info);
        if (r_symndx < symtab_hdr->sh_info)
          h = NULL;
        else
          h = sym_hashes[r_symndx - symtab_hdr->sh_info];
  
!       switch (ELF32_R_TYPE (rel->r_info))
          {
          /* This relocation describes the C++ object vtable hierarchy.
             Reconstruct it for later use during GC.  */
          case R_M32R_GNU_VTINHERIT:
            if (!_bfd_elf32_gc_record_vtinherit (abfd, sec, h, rel->r_offset))
              return FALSE;
--- 4411,4660 ----
    struct elf_link_hash_entry **sym_hashes, **sym_hashes_end;
    const Elf_Internal_Rela *rel;
    const Elf_Internal_Rela *rel_end;
+   struct elf_m32r_link_hash_table *htab;
+   bfd *dynobj;
+   bfd_vma *local_got_offsets;
+   asection *sgot, *srelgot, *sreloc;
  
    if (info->relocatable)
      return TRUE;
  
+   sgot = srelgot = sreloc = NULL;
+ 
    symtab_hdr = &elf_tdata (abfd)->symtab_hdr;
    sym_hashes = elf_sym_hashes (abfd);
    sym_hashes_end = sym_hashes + symtab_hdr->sh_size/sizeof (Elf32_External_Sym);
    if (!elf_bad_symtab (abfd))
      sym_hashes_end -= symtab_hdr->sh_info;
  
+   htab = m32r_elf_hash_table (info);
+   dynobj = htab->root.dynobj;
+   local_got_offsets = elf_local_got_offsets (abfd);
+ 
    rel_end = relocs + sec->reloc_count;
    for (rel = relocs; rel < rel_end; rel++)
      {
+       int r_type;
        struct elf_link_hash_entry *h;
        unsigned long r_symndx;
  
        r_symndx = ELF32_R_SYM (rel->r_info);
+       r_type = ELF32_R_TYPE (rel->r_info);
        if (r_symndx < symtab_hdr->sh_info)
          h = NULL;
        else
          h = sym_hashes[r_symndx - symtab_hdr->sh_info];
  
!       /* Some relocs require a global offset table.  */
!       if (htab->sgot == NULL)
!         {
!           switch (r_type)
!             {
!             case R_M32R_GOT16_HI_ULO:
!             case R_M32R_GOT16_HI_SLO:
!             case R_M32R_GOT16_LO:
!             case R_M32R_GOTPC24:
!             case R_M32R_GOTPC_HI_ULO:
!             case R_M32R_GOTPC_HI_SLO:
!             case R_M32R_GOTPC_LO:
!             case R_M32R_GOT24:
!               if (dynobj == NULL)
!                 htab->root.dynobj = dynobj = abfd;
!               if (! create_got_section (dynobj, info))
!                 return FALSE;
!               break;
! 
!             default:
!               break;
!           }
!         }
! 
!       switch (r_type)
          {
+ 	case R_M32R_GOT16_HI_ULO:
+ 	case R_M32R_GOT16_HI_SLO:
+ 	case R_M32R_GOT16_LO: 
+         case R_M32R_GOT24:
+ 
+           if (h != NULL)
+             h->got.refcount += 1;
+           else
+             {
+               bfd_signed_vma *local_got_refcounts;
+ 
+               /* This is a global offset table entry for a local
+                  symbol.  */
+               local_got_refcounts = elf_local_got_refcounts (abfd);
+               if (local_got_refcounts == NULL)
+                 {
+                   bfd_size_type size;
+ 
+                   size = symtab_hdr->sh_info;
+                   size *= sizeof (bfd_signed_vma);
+                   local_got_refcounts = ((bfd_signed_vma *)
+                                          bfd_zalloc (abfd, size));
+                   if (local_got_refcounts == NULL)
+                     return FALSE;
+                   elf_local_got_refcounts (abfd) = local_got_refcounts;
+                 }
+               local_got_refcounts[r_symndx] += 1;
+             }
+           break;
+ 
+         case R_M32R_26_PLTREL:
+           /* This symbol requires a procedure linkage table entry.  We
+              actually build the entry in adjust_dynamic_symbol,
+              because this might be a case of linking PIC code without
+              linking in any dynamic objects, in which case we don't
+              need to generate a procedure linkage table after all.  */
+  
+ 	  /* If this is a local symbol, we resolve it directly without
+ 	     creating a procedure linkage table entry.  */
+           if (h == NULL)
+             continue;
+ 
+           if (h->elf_link_hash_flags & ELF_LINK_FORCED_LOCAL)
+             break;
+ 
+           h->elf_link_hash_flags |= ELF_LINK_HASH_NEEDS_PLT;
+ 	  h->plt.refcount += 1;
+           break;
+ 
+         case R_M32R_16_RELA:
+         case R_M32R_24_RELA:
+         case R_M32R_32_RELA:
+         case R_M32R_HI16_ULO_RELA:
+         case R_M32R_HI16_SLO_RELA:
+         case R_M32R_LO16_RELA:
+         case R_M32R_SDA16_RELA:
+         case R_M32R_18_PCREL_RELA:
+         case R_M32R_26_PCREL_RELA:
+ 
+           if (h != NULL && !info->shared)
+             {
+               h->elf_link_hash_flags |= ELF_LINK_NON_GOT_REF;
+               h->plt.refcount += 1;
+             }
+ 
+           /* If we are creating a shared library, and this is a reloc
+              against a global symbol, or a non PC relative reloc
+              against a local symbol, then we need to copy the reloc
+              into the shared library.  However, if we are linking with
+              -Bsymbolic, we do not need to copy a reloc against a
+              global symbol which is defined in an object we are
+              including in the link (i.e., DEF_REGULAR is set).  At
+              this point we have not seen all the input files, so it is
+              possible that DEF_REGULAR is not set now but will be set
+              later (it is never cleared).  We account for that
+              possibility below by storing information in the
+              dyn_relocs field of the hash table entry. A similar
+              situation occurs when creating shared libraries and symbol
+              visibility changes render the symbol local.
+ 
+              If on the other hand, we are creating an executable, we
+              may need to keep relocations for symbols satisfied by a
+              dynamic library if we manage to avoid copy relocs for the
+              symbol.  */
+           if ((info->shared
+                && (sec->flags & SEC_ALLOC) != 0
+ 	       && ((r_type != R_M32R_26_PCREL_RELA
+                     && r_type != R_M32R_18_PCREL_RELA)
+ 	           || (h != NULL
+ 		       && (! info->symbolic
+ 		           || h->root.type == bfd_link_hash_defweak
+ 		           || (h->elf_link_hash_flags
+ 		               & ELF_LINK_HASH_DEF_REGULAR) == 0))))
+               || (!info->shared
+                   && (sec->flags & SEC_ALLOC) != 0
+                   && h != NULL
+                   && (h->root.type == bfd_link_hash_defweak
+                       || (h->elf_link_hash_flags
+                           & ELF_LINK_HASH_DEF_REGULAR) == 0)))
+             {
+               struct elf_m32r_dyn_relocs *p;
+               struct elf_m32r_dyn_relocs **head;
+ 
+               if (dynobj == NULL)
+                 htab->root.dynobj = dynobj = abfd;
+ 
+               /* When creating a shared object, we must copy these
+                  relocs into the output file.  We create a reloc
+                  section in dynobj and make room for the reloc.  */
+               if (sreloc == NULL)
+                 {
+                   const char *name;
+  
+                   name = (bfd_elf_string_from_elf_section
+                           (abfd,
+                            elf_elfheader (abfd)->e_shstrndx,
+                            elf_section_data (sec)->rel_hdr.sh_name));
+                   if (name == NULL)
+                     return FALSE;
+  
+                   BFD_ASSERT (strncmp (name, ".rela", 5) == 0
+                               && strcmp (bfd_get_section_name (abfd, sec),
+                                          name + 5) == 0);
+  
+                   sreloc = bfd_get_section_by_name (dynobj, name);
+                   if (sreloc == NULL)
+                     {
+                       flagword flags;
+  
+                       sreloc = bfd_make_section (dynobj, name);
+                       flags = (SEC_HAS_CONTENTS | SEC_READONLY
+                                | SEC_IN_MEMORY | SEC_LINKER_CREATED);
+                       if ((sec->flags & SEC_ALLOC) != 0)
+                         flags |= SEC_ALLOC | SEC_LOAD;
+                       if (sreloc == NULL
+                           || ! bfd_set_section_flags (dynobj, sreloc, flags)
+                           || ! bfd_set_section_alignment (dynobj, sreloc, 2))
+                         return FALSE;
+                     }
+                   elf_section_data (sec)->sreloc = sreloc;
+                 }
+  
+               /* If this is a global symbol, we count the number of
+                  relocations we need for this symbol.  */
+               if (h != NULL)
+                 head = &((struct elf_m32r_link_hash_entry *) h)->dyn_relocs;
+               else
+                 {
+                   asection *s;
+ 
+                   /* Track dynamic relocs needed for local syms too.  */
+                   s = bfd_section_from_r_symndx (abfd, &htab->sym_sec,
+                                                  sec, r_symndx);
+                   if (s == NULL)
+                     return FALSE;
+ 
+                   head = ((struct elf_m32r_dyn_relocs **)
+                           &elf_section_data (s)->local_dynrel);
+                 }
+ 
+               p = *head;
+               if (p == NULL || p->sec != sec)
+                 {
+                   bfd_size_type amt = sizeof (*p);
+                   p = ((struct elf_m32r_dyn_relocs *) bfd_alloc (dynobj, amt));
+                   if (p == NULL)
+                     return FALSE;
+                   p->next = *head;
+                   *head = p;
+                   p->sec = sec;
+                   p->count = 0;
+                   p->pc_count = 0;
+                 }
+ 
+               p->count += 1;
+               if (ELF32_R_TYPE (rel->r_info) == R_M32R_26_PCREL_RELA
+                   || ELF32_R_TYPE (rel->r_info) == R_M32R_18_PCREL_RELA)
+                 p->pc_count += 1;
+             }
+           break;
+ 
          /* This relocation describes the C++ object vtable hierarchy.
             Reconstruct it for later use during GC.  */
+         case R_M32R_RELA_GNU_VTINHERIT:
          case R_M32R_GNU_VTINHERIT:
            if (!_bfd_elf32_gc_record_vtinherit (abfd, sec, h, rel->r_offset))
              return FALSE;
***************
*** 2091,2096 ****
--- 4666,4675 ----
            if (!_bfd_elf32_gc_record_vtentry (abfd, sec, h, rel->r_offset))
              return FALSE;
            break;
+         case R_M32R_RELA_GNU_VTENTRY:
+           if (!_bfd_elf32_gc_record_vtentry (abfd, sec, h, rel->r_addend))
+             return FALSE;
+           break;
          }
      }
  
***************
*** 2103,2108 ****
--- 4682,4742 ----
    { ".sbss",    5, -2, SHT_NOBITS,   SHF_ALLOC + SHF_WRITE },
    { NULL,       0,  0, 0,            0 }
  };
+ 
+ static bfd_boolean
+ m32r_elf_fake_sections (abfd, hdr, sec)
+      bfd *abfd;
+      Elf_Internal_Shdr *hdr ATTRIBUTE_UNUSED;
+      asection *sec;
+ {
+   register const char *name;
+ 
+   name = bfd_get_section_name (abfd, sec);
+ 
+   /* The generic elf_fake_sections will set up REL_HDR using the
+      default kind of relocations.  But, we may actually need both
+      kinds of relocations, so we set up the second header here.
+ 
+      This is not necessary for the O32 ABI since that only uses Elf32_Rel
+      relocations (cf. System V ABI, MIPS RISC Processor Supplement,
+      3rd Edition, p. 4-17).  It breaks the IRIX 5/6 32-bit ld, since one
+      of the resulting empty .rela.<section> sections starts with
+      sh_offset == object size, and ld doesn't allow that.  While the check
+      is arguably bogus for empty or SHT_NOBITS sections, it can easily be
+      avoided by not emitting those useless sections in the first place.  */
+   if ((sec->flags & SEC_RELOC) != 0)
+     {
+       struct bfd_elf_section_data *esd;
+       bfd_size_type amt = sizeof (Elf_Internal_Shdr);
+ 
+       esd = elf_section_data (sec);
+       BFD_ASSERT (esd->rel_hdr2 == NULL);
+       esd->rel_hdr2 = (Elf_Internal_Shdr *) bfd_zalloc (abfd, amt);
+       if (!esd->rel_hdr2)
+         return FALSE;
+       _bfd_elf_init_reloc_shdr (abfd, esd->rel_hdr2, sec,
+                                 !sec->use_rela_p);
+     }
+ 
+   return TRUE;
+ }
+ 
+ static enum elf_reloc_type_class
+ m32r_elf_reloc_type_class (rela)
+      const Elf_Internal_Rela *rela;
+ {
+   switch ((int) ELF32_R_TYPE (rela->r_info))
+     {
+     case R_M32R_RELATIVE:
+       return reloc_class_relative;
+     case R_M32R_JMP_SLOT:
+       return reloc_class_plt;
+     case R_M32R_COPY:
+       return reloc_class_copy;
+     default:
+       return reloc_class_normal;
+     }
+ }
  
  #define ELF_ARCH		bfd_arch_m32r
  #define ELF_MACHINE_CODE	EM_M32R
***************
*** 2111,2118 ****
  
  #define TARGET_BIG_SYM          bfd_elf32_m32r_vec
  #define TARGET_BIG_NAME		"elf32-m32r"
  
! #define elf_info_to_howto			0
  #define elf_info_to_howto_rel			m32r_info_to_howto_rel
  #define elf_backend_section_from_bfd_section	_bfd_m32r_elf_section_from_bfd_section
  #define elf_backend_symbol_processing		_bfd_m32r_elf_symbol_processing
--- 4745,4754 ----
  
  #define TARGET_BIG_SYM          bfd_elf32_m32r_vec
  #define TARGET_BIG_NAME		"elf32-m32r"
+ #define TARGET_LITTLE_SYM       bfd_elf32_m32rle_vec
+ #define TARGET_LITTLE_NAME      "elf32-m32rle"
  
! #define elf_info_to_howto			m32r_info_to_howto
  #define elf_info_to_howto_rel			m32r_info_to_howto_rel
  #define elf_backend_section_from_bfd_section	_bfd_m32r_elf_section_from_bfd_section
  #define elf_backend_symbol_processing		_bfd_m32r_elf_symbol_processing
